// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

assertEquals("1", v8ToStringRT(1));
assertEquals("1", v8ToStringRT(1));

assertEquals("0.5", v8ToStringRT(.5));
assertEquals("0.5", v8ToStringRT(.5));

assertEquals("null", v8ToStringRT(null));
assertEquals("null", v8ToStringRT(null));

assertEquals("true", v8ToStringRT(true));
assertEquals("true", v8ToStringRT(true));

assertEquals("false", v8ToStringRT(false));
assertEquals("false", v8ToStringRT(false));

assertEquals("undefined", v8ToStringRT(undefined));
assertEquals("undefined", v8ToStringRT(undefined));

assertEquals("random text", v8ToStringRT("random text"));
assertEquals("random text", v8ToStringRT("random text"));

assertThrows(function() { v8ToStringRT(Symbol.toPrimitive) }, TypeError);
assertThrows(function() { v8ToStringRT(Symbol.toPrimitive) }, TypeError);

var a = { toString: function() { return "xyz" }};
assertEquals("xyz", v8ToStringRT(a));
assertEquals("xyz", v8ToStringRT(a));

var b = { valueOf: function() { return 42 }};
assertEquals("[object Object]", v8ToStringRT(b));
assertEquals("[object Object]", v8ToStringRT(b));

var c = {
  toString: function() { return "x"},
  valueOf: function() { return 123 }
};
assertEquals("x", v8ToStringRT(c));
assertEquals("x", v8ToStringRT(c));

var d = {
  [Symbol.toPrimitive]: function(hint) { return hint }
};
assertEquals("string", v8ToStringRT(d));
assertEquals("string", v8ToStringRT(d));

var e = new Date(0);
assertEquals(e.toString(), v8ToStringRT(e));
assertEquals(e.toString(), v8ToStringRT(e));
